2026-01-18  Karl Berry  <karl@freefriends.org>

	* luatexdir/tex/errors.c (print_ignored_err): send "ignored error"
	output only to log file.

2026-01-15  Karl Berry  <karl@freefriends.org>

	* luatexdir/tex/errors.c (print_ignored_err): omit word "error" in
	message to avoid false positives by humans and editors (cross-engine).
	https://tug.org/pipermail/pdftex/2026-January/009463.html

2025-12-06  Luigi Scarso  <luigi.scarso@gmail.com>
	* set_macro needs to check if the space is the only character
	  after a backslash before removing a "trailing" space
	  (thanks to Udi Fogiel and H.Hagen)
	* fixed wrong spacing around display with \matheqdirmode=1. WORK IN PROGRESS (Udi Fogiel)
	* fixed Errors in "texlua" do not print a traceback (Max Chernoff)
      
2025-09-23  Luigi Scarso  <luigi.scarso@gmail.com>
	* Fixed scan_keywordcs typo in the manual  (Max Chernoff)


2025-09-19  Luigi Scarso  <luigi.scarso@gmail.com>
	* Included in writeimg.c the correct header  <kpathsea/absolute.h>
	  for kpse_absolute_p 

	
2025-09-14  Karl Berry  <karl@freefriends.org>

	* luaoutputdir.test (tests): mkdir top-level subdir.
	Report from Maxim Cournoyer, tex-live 12 Sep 2025 22:42:53.


2025-09-14  Luigi Scarso  <luigi.scarso@gmail.com>
	* Fixed read_img, it  now checks --output-dir (thanks to reescf@gmail.com)
	* Added the $(ENVLUATEXCPPFLAGS) and $(ENVLUAJITEXCPPFLAGS) variables to libluatex.am
	  to add compiler switches from the environment.

2025-09-02  Luigi Scarso  <luigi.scarso@gmail.com>
	* Fix field names of mplib.stats (thanks to Josef Friedrich)
        * Fixed a wrong date in luatex-nodes.tex.


2025-09-01 Luigi Scarso  <luigi.scarso@gmail.com>
	* WORK IN PROGRESS: Various fixes for C23 compatibility. LuaTeX 1.24.0 


2025-07-15 Luigi Scarso  <luigi.scarso@gmail.com>
	* Fixed a paragraph misplacement in luatex-languages.tex (thanks to Josef Friedrich)


2025-07-15 Luigi Scarso  <luigi.scarso@gmail.com>
	* Fixed typos in mathcodes.c (thanks to Josef Friedrich)

	
2025-07-05 Luigi Scarso  <luigi.scarso@gmail.com>
	* Fix for legacy handling of truetype fonts (thanks to marcpenninga)


2025-07-01 Luigi Scarso  <luigi.scarso@gmail.com>
	* max size of the destination names table for PDF output raised to 1048576  (Max Chernoff)


2025-06-24 Luigi Scarso  <luigi.scarso@gmail.com>
	* Restored \mathflattenmode (M.F. Krüger)
	* LuaTeX 1.23.3 


2025-05-30 Luigi Scarso  <luigi.scarso@gmail.com>
	* additional 'value' field for write nodes (getfield) for
	  unexpanded token tables (H.Hagen)
	* LuaTeX 1.23.2 


2025-04-17 Luigi Scarso  <luigi.scarso@gmail.com>
	* experimental extension to ToUnicode for Type1 fonts (HH)
	* Document the table variant of `character.tounicode` (Max Chernoff)


2025-03-20 Luigi Scarso  <luigi.scarso@gmail.com>
	*  some more never used modes made obsolete + staircase kerns adapted (H.Hagen)
	*  LuaTeX 1.23.1


2025-03-18 Luigi Scarso  <luigi.scarso@gmail.com>
	*  LuaTeX 1.23.0


025-03-17 Luigi Scarso  <luigi.scarso@gmail.com>
	*  final solution for italic (H.Hagen)


2025-03-16 Luigi Scarso  <luigi.scarso@gmail.com>
	* always use old school tex logic (also for opentype) wrt italics
	  with exception for large operators in opentyep fonts (no mixed font
          usage); all related control modes removed (H.Hagen)


2025-03-15 Luigi Scarso  <luigi.scarso@gmail.com>
	* italicsmode fix for eight bit fonts (H.Hagen)

	
2025-03-13 Luigi Scarso  <luigi.scarso@gmail.com>
	* extra italicsmode (large operator italic spacing) (H.Hagen)

	
2025-02-28  Akira Kakuto  <kakuto@jcom.zaq.ne.jp>
	* luatex.c: Remove problematic lines for windows


2025-02-19 Luigi Scarso <luigi.scarso@gmail.com>
	* Fixed ffi.h for OSX on arm64

	
2025-02-10 Luigi Scarso <luigi.scarso@gmail.com>
	* Updated \tracinglostchars. 4: early warning (and force terminal); >4: early error.

	
2025-02-09 Luigi Scarso <luigi.scarso@gmail.com>
	* fixed shell-escape bypass (thanks to tex@maxchernoff.ca)
	* Add token.unchecked_put_next, support setting the environment
	  with os.spawn, permit usage of the img module in texlua mode
	  (thanks to tex@maxchernoff.ca)
	
	
2025-02-05 Luigi Scarso <luigi.scarso@gmail.com>
	* add mathemptydisplaymode primitive, 
	* fix nodes leak in end_graf (thanks to udifoglle@gmail.com)


2025-02-02 Luigi Scarso <luigi.scarso@gmail.com>
	* Fixed subtype of beforedisplaypenalty (thanks to udifoglle@gmail.com)


2025-02-01 Luigi Scarso <luigi.scarso@gmail.com>
	* LuaJIT 2.1.1736781742 (work in progress)
	* LuaTeX 1.21.0


2025-02-01 Luigi Scarso <luigi.scarso@gmail.com>
	* Again on missing displacement when leqno is used in rtl paragraph (thanks to udifoglle@gmail.com)
	* LuaTeX 1.20.8


2025-02-01 Luigi Scarso <luigi.scarso@gmail.com>
	* Fix getdisc tail fields and some related sanity check cleanup (HH)
	* LuaTeX 1.20.7


2025-02-01 Luigi Scarso <luigi.scarso@gmail.com>
	* Fixed missing displacement when leqno is used in rtl paragraph (thanks to udifoglle@gmail.com)
	* LuaTeX 1.20.6


2025-01-31 Luigi Scarso <luigi.scarso@gmail.com>
	* In read_tfm_info avoid scaling fonts to >= 2048pt, which can cause overflow (TeXLive rev. 73614)
	* \ignoreprimitiveerror as in pdftex


2025-01-19 Luigi Scarso <luigi.scarso@gmail.com>
	* Fixed \shapemode does not reset at end of paragraphs (thanks to udifoglle@gmail.com)


2025-01-18 Luigi Scarso <luigi.scarso@gmail.com>
	* In output_name_tree, sort_dest_names now compares literal strings or hexdecimal strings. 
	* LuaTeX 1.20.5


2025-01-11 Luigi Scarso <luigi.scarso@gmail.com>
	* fixed "unexpected delimiter construction with classic tfm cmex font", 
	  see https://tex.stackexchange.com/a/734734/1090 (HH)
	* LuaTeX 1.20.4


2025-01-09 Luigi Scarso <luigi.scarso@gmail.com>
	* replaced # error with # define UNSUPPORTED_ARCH in ffi.[ch]
	* LuaTeX 1.20.3


2025-01-06 Luigi Scarso <luigi.scarso@gmail.com>
	* ffi.h: do not assume that struct cdata is aligned(16). 
	* More fixes for luaffi.
	* LuaTeX 1.20.2


2025-01-04 Luigi Scarso <luigi.scarso@gmail.com>
	* Clean-up ffi.h
	* LuaTeX 1.20.1


2025-01-02 Luigi Scarso <luigi.scarso@gmail.com>
	* New luaffi, support for aarch64.
	* LuaTeX 1.20.0


2024-12-30 Luigi Scarso <luigi.scarso@gmail.com>
	* Increment tally in tprint also when doterm is true (thanks to user202729@protonmail.com).
	* LuaTeX 1.19.4


2024-12-30 Luigi Scarso <luigi.scarso@gmail.com>
	* Avoid useless 0 beginbfrange endbfrange in pdf 
	* LuaTeX 1.19.3


2024-12-24 Luigi Scarso <luigi.scarso@gmail.com>
	* For PNG, we no longer set the attr on the mask. If we get a report about dropping this 
          we could add a 'maskattr' feature, but one should consider
          to include a correct pdf of the image instead, it's more robust.
	* LuaTeX 1.19.2


2024-11-02  Luigi Scarso <luigi.scarso@gmail.com>
	* Fixed a memory leak in token.put_next()  (thanks to user202729@protonmail.com)
	* Fixed a memory leak in token.set_macro() implementation (thanks to user202729@protonmail.com)


2024-10-12  Luigi Scarso <luigi.scarso@gmail.com>
	* Handle token combiners in immediate assignments (H.Hagen)
	* LuaTeX 1.19.0


2024-09-15  Luigi Scarso <luigi.scarso@gmail.com>
	* Fixed a typo in texfont.c (thanks to Josef Friedrich)


2024-09-01  Luigi Scarso <luigi.scarso@gmail.com>
        * Changed char utf8word[(4 * MAX_WORD_LEN) + 1] = { 0 };
	in char utf8word[(4 * MAX_WORD_LEN) + 1] ;
	in function  void hnj_hyphenation(halfword head, halfword tail) (thanks to user202729@protonmail.com)

2024-05-11  Luigi Scarso <luigi.scarso@gmail.com>
        * allow interactive deletion of \outer token, see https://tug.org/texmfbug/newbug.html#B142outer 


2024-05-13  Luigi Scarso <luigi.scarso@gmail.com>
	* Omitprocset and ptexprefix (force _ instead of . as separator) (H.Hagen)
	* Bump to version 1.18.2

2024-03-25  Luigi Scarso <luigi.scarso@gmail.com>
	* Fixed synctex message on a math node with no zero glue

2024-03-20  Luigi Scarso <luigi.scarso@gmail.com>
	* Fixed wrong initialization of startup_filename (thanks to Wang Weixuan).


2024-03-10  Karl Berry  <karl@tug.org>

	* TL'24 release.

2024-02-29  Luigi Scarso <luigi.scarso@gmail.com>
	* Default output of \tracingmacros as in pdftex; texconfig.trace_extra_newline adds a newline in \tracingmacros as before (H.Hagen).


2024-02-20  Luigi Scarso <luigi.scarso@gmail.com>
	* in kpse mode, --shell-escape enable the standard lfs.* and os.* functions otherwise protected
        * fixed lfs.mkdirp return value


2024-02-19  Luigi Scarso <luigi.scarso@gmail.com>
        *  new function lfs.mkdirp -- make parent directories as needed.


2024-02-04  Luigi Scarso <luigi.scarso@gmail.com>
	* LuaTeX 1.18.0.


2024-02-04  Luigi Scarso <luigi.scarso@gmail.com>
	* Character index within the  limits in defining a Type 3 font (H.Hagen). Thanks M. Chernoff.

	
2024-02-03  Luigi Scarso <luigi.scarso@gmail.com>
	* Ensures that setgentounicode has a glyph_unicode_tree not NULL (thanks M. Chernoff)

	
2024-01-29  Luigi Scarso <luigi.scarso@gmail.com>
	*  Integrate interval mode of metapost (as binary, it's not used in luatex)


2024-01-28  Luigi Scarso <luigi.scarso@gmail.com>
	* By default now debug.traceback is not nil.

	
2024-01-27  Luigi Scarso <luigi.scarso@gmail.com>
	* lfs.attributes, lfs.dir and lfs.symlinkattributes are now checked
	  only against kpse.in_name_ok_silent_extended
	

2024-01-24  Luigi Scarso <luigi.scarso@gmail.com>
        * New 	kpse.in_name_ok_silent_extended and kpse.in_name_ok_silent_extended
        * In kpse mode
	  os.rename,
          os.remove
          lfs.attributes,
	  lfs.chdir,
	  lfs.lock_dir,
	  lfs.dir,
	  lfs.link ,
	  lfs.mkdir,
	  lfs.rmdir,
	  lfs.symlinkattributes,
	  lfs.touch 
        are now checked with kpse.in_name_ok_silent_extended  *and* kpse.out_name_ok_silent_extended
        * TEXMF_OUTPUT_DIRECTORY and output_directory have the same value, output_directory (when not empty)
          having higher priority than TEXMF_OUTPUT_DIRECTORY.

2024-01-21  Luigi Scarso <luigi.scarso@gmail.com>
	*  Fixed position of verbatim_written in mpxout.w


2024-01-13  Luigi Scarso <luigi.scarso@gmail.com>
	*  Added missed definition of P_tmpdir for  splinefont.c .

	

2024-01-04  Luigi Scarso <luigi.scarso@gmail.com> 
        * With --safer now each function in debug is nil as also package.loaded.debug = nil and  debug = nil 


2023-12-21  Luigi Scarso <luigi.scarso@gmail.com> 
        * LuaTeX 1.17.1	
        * New commandline switch --[no-]check-dvi-total-pages  exit when DVI exceeds 65535 pages (default: check).
          This breaks backward compatibility.


2023-11-20  Karl Berry  <karl@freefriends.org>

        * luazlib/lzlib.c: relax zlib version check to just checking
        the major version, since (it turns out) zlib 1.3 is compatible
        with 1.2.
        https://github.com/TeX-Live/texlive-source/pull/62
        https://lists.debian.org/debian-tex-maint/2010/06/msg00074.html
        https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=581818

2023-11-05  Luigi Scarso <luigi.scarso@gmail.com> 
	* New binding for in_name_ok, out_name_ok from kpathsea. 
	* When status.kpse_used = 1 io.open checks if the filename is ok
          with in_name_ok or out_name_ok.

2023-11-02  Luigi Scarso <luigi.scarso@gmail.com> 
	* Fix for dubious cff fonts (not following the 1000 unit recommendation) (Hans Hagen).

2023-10-04  Karl Berry  <karl@freefriends.org>

	* luaoutputdir.test: new test for Lua-level reading from a given
	--output-directory.
	* am/luatex.am (luatex_tests): add it, plus .log dependency.

2023-04-29  Luigi Scarso <luigi.scarso@gmail.com> 
    * LuaTeX 1.17.0

2023-04-28  Luigi Scarso <luigi.scarso@gmail.com> 
    * new option --no-socket, same as --nosocket

2023-04-27  Luigi Scarso <luigi.scarso@gmail.com> 
    * new option --socket to split socket and shell escape;
    * the mime library is always available  (Max Chernoff);
    * Fixed ChangeLog

2023-04-25  Luigi Scarso <luigi.scarso@gmail.com> 
    * socket library by default not enabled; 
       it is enabled with --shell-escape but not with --shell-restricted.
       The option ---nosocket remains unchanged.
       The two new functions os.socketgettime and os.socketsleep are 
       like socket.gettime and socket.sleep, but they are always available.
    * Luatex 1.17.0

2023-04-24  Luigi Scarso <luigi.scarso@gmail.com> 
    * static kpse.check_permissions in os.kpsepopen
    * Fixed date in ChangeLog

2023-04-23  Luigi Scarso <luigi.scarso@gmail.com> 
    * new os.kpsepopen -- replace  io.popen if kpse is active.
    * Luatex 1.16.2

2023-04-18  Luigi Scarso <luigi.scarso@gmail.com> 
    * lua.setluaname(n, s) and lua.getluaname(n): 
      fixed mismatch between documentation and implementation (J. Friedrich).

2023-03-30  Luigi Scarso <luigi.scarso@gmail.com> 
    * bugfix for setpdforigin()  (A. Matthias) 

2023-02-22  Luigi Scarso <luigi.scarso@gmail.com> 
    * fix latelua data reference (side effect of deferred late additions) (H.Hagen)

2023-02-18  Luigi Scarso <luigi.scarso@gmail.com> 
    * Fixed the "Invalid unicode ranges in CMap beginbfrange operator bug" as in pdfTeX (Hàn Thế Thành)

2023-02-18  Luigi Scarso <luigi.scarso@gmail.com> 
    * new "late special" feature by Phelype Oleinik,
      heavily adapted by H.Hagen.

2023-02-05  Luigi Scarso <luigi.scarso@gmail.com> 
    *  Fix typos (thanks to J. Friedrich) 

2023-01-24  Luigi Scarso <luigi.scarso@gmail.com> 
    *  fix for r2l multiline link etc rectangles (H.Hagen)

2023-01-17  Luigi Scarso <luigi.scarso@gmail.com> 
    * \pdfvariable omitmediabox 1 (H.Hagen)
    * luatex 1.16.0

2022-12-05  Luigi Scarso <luigi.scarso@gmail.com> 
    * complementary patch for revision 7551 (lua end compatibility) (H.Hagen)

2022-12-03  Luigi Scarso <luigi.scarso@gmail.com> 
    * Track last node in ligature handling (M.Krüger)

2022-12-03  Luigi Scarso <luigi.scarso@gmail.com> 
    * Make disc node prev. pointers more uniform (M.Krüger)

2022-11-20  Luigi Scarso <luigi.scarso@gmail.com> 
    * set \variablefam = -1 as initial value (H.Hagen).

2022-11-20  Luigi Scarso <luigi.scarso@gmail.com> 
    * Ensured that load_hyphenation has enough Lua stack, and pops the latest table pushed in (Michal Vlasák).

2022-11-10  Luigi Scarso <luigi.scarso@gmail.com> 
    * Better error message if setlocale fails

2022-10-28  Luigi Scarso <luigi.scarso@gmail.com> 
    * \variablefam (backport from luametatex, handy for latex) (H .Hagen)

2022-10-22  Luigi Scarso <luigi.scarso@gmail.com> 
     * STOP COMMITS TO SVN REPO -- WORK IN PROGRESS

2022-10-22  Luigi Scarso <luigi.scarso@gmail.com> 
     * porting texlive patch r53155 -- WORK IN PROGRESS

2022-09-29  Luigi Scarso <luigi.scarso@gmail.com> 
     * Fixed an infinite loop with --halt-on-error option (K.Berry)

2022-08-16  Luigi Scarso <luigi.scarso@gmail.com> 
     * Accent 0xFFFD but still error on invalid utf (compatible) (H.Hagen)
     * omitinfodict added: \pdfvariable omitinfodict 1 omit Info dicttionary (H.Hagen)

2022-08-05  Luigi Scarso <luigi.scarso@gmail.com> 
     * Fixed a missed lua_settop in lua_appendtovlist_callback() (thanks to Hironori KITAGAWA)

2022-07-31  Luigi Scarso <luigi.scarso@gmail.com>
    * Fixed loading .tex when  --output-directory is enabled

2022-07-30  Luigi Scarso <luigi.scarso@gmail.com>
    * Backtrack replace pointer when successive disc in exceptions  (H.Hagen)

2022-07-30  Luigi Scarso <luigi.scarso@gmail.com>
    * Take exception pre/port disc font from wordstart (H.Hagen)

2022-05-23  Luigi Scarso <luigi.scarso@gmail.com>
    * Fixed mp_begin_iteration (H.Hagen)

2022-05-15  Luigi Scarso <luigi.scarso@gmail.com>
    * Fixed a memory leak in mplib (H.Hagen)

2022-04-26  Luigi Scarso <luigi.scarso@gmail.com>
    * \mathitalicsmode=2 (enforce old school fonts italics code path) (H.Hagen)

2022-04-25  Luigi Scarso <luigi.scarso@gmail.com>
    * kpse find_file and lookup also search in --output-directory

2022-04-21  Luigi Scarso <luigi.scarso@gmail.com>
    * Wrong array size extended node_fields_whatsit_pdf_action (HH)

2022-04-18 Luigi Scarso <luigi.scarso@gmail.com>
    * Fix for Bug: Null-byte in csname not handled correctly (thanks to H. Menke)

2022-04-13 Luigi Scarso <luigi.scarso@gmail.com>
    * Make require return an error for ffi without shell-escape (H. Menke)

2022-04-12  Luigi Scarso <luigi.scarso@gmail.com>
    * Fix for 'Bug: attempt to double-free kern node'; 
      restore safeguard math (HH). Thanks to H. Menke

2022-03-21  Karl Berry  <karl@tug.org>

	* TL'22 release.

2022-03-10 Luigi Scarso <luigi.scarso@gmail.com>
    *  -[no-]parse-first-line is now an unrecognized option (thanks to K.Berry)

2022-02-28 Luigi Scarso <luigi.scarso@gmail.com>
    * pass node to latelua function call (H.Hagen)

2022-02-27 Luigi Scarso <luigi.scarso@gmail.com>
    * Development id also with --version.

2022-02-26 Luigi Scarso <luigi.scarso@gmail.com>
    * write xformattributes and xformresources  (thanks to E. Renkema)

2022-02-25 Luigi Scarso <luigi.scarso@gmail.com>
    * lower max to 10000 and reverse check to max check exception penalty (H.Hagen)

2022-02-05 Luigi Scarso <luigi.scarso@gmail.com>
    *  intercept prefix for toksapp cum suis (H.Hagen)

2022-01-23 Luigi Scarso <luigi.scarso@gmail.com>
    * fixing a 15 year old buglet (math atom glue leak).  
    * New primitive \matheqdirmode for short skip detection in  r2l typesetting (H. Hagen)

2022-01-21 Luigi Scarso <luigi.scarso@gmail.com>
    * patch for the logging of \scantextokens (H. Hagen)

2022-01-17 Siep Kroonenberg <siepo@bitmuis.nl>
   * patch for inconsistent definitions inet_ntop/inet_pton

2022-01-12 Luigi Scarso <luigi.scarso@gmail.com>
   * fixed \showstream (M.Krüger)

2021-12-31 Luigi Scarso <luigi.scarso@gmail.com>
    * drop (for the moment) \showstream

2021-12-30 Luigi Scarso <luigi.scarso@gmail.com>
    * struct dest (M.Krüger)
    * fixed  a 'Conditional jump or move depends on uninitialised value(s)' msg from valgrind

2021-12-29 Luigi Scarso <luigi.scarso@gmail.com>
    * Correctly print \write for the error message 
      "Forbidden control sequence found while scanning text of"
      (thanks to Hironobu Yamashita)

2021-12-27 Luigi Scarso <luigi.scarso@gmail.com>
    * fixed a typo in a tex comment.

2021-12-24 Luigi Scarso <luigi.scarso@gmail.com>
    * Metapost: make sure that an already open VF is closed before to read a new one

2021-12-21 Luigi Scarso <luigi.scarso@gmail.com>
    * fixed os.uname on 64 bit Windows (A. Kakuto, L. Scarso)

2021-12-13 Luigi Scarso <luigi.scarso@gmail.com>
    * fixed a typo in equivalents.c (user202729 @ https://chat.stackexchange.com/transcript/41/2021/12/12)

2021-12-07 Luigi Scarso <luigi.scarso@gmail.com>
    * Fixed a typo in maincontrol.c (thanks to Hironobu Yamashita)

2021-11-20 Luigi Scarso <luigi.scarso@gmail.com>
    * Ignore paragraphs with only a local par node followed by direction synchronization
    nodes (paragraphs like that are seen as empty paragraphs) (HH)

2021-08-28 Luigi Scarso <luigi.scarso@gmail.com>
    *more efficient fontdimen allocation (HH)

2021-08-12 Luigi Scarso <luigi.scarso@gmail.com>
    *mplibdir: Fix _findfirst handle truncation on Windows x86_64. 
     Thanks to Richard Copley.

2021-08-08 Luigi Scarso <luigi.scarso@gmail.com>
    *Improvements for glyph_stream_provider with TTF fonts (MK)

2021-08-04 Luigi Scarso <luigi.scarso@gmail.com>
    *Fix named instance inconsistency in luaharfbuzz (MK)

2021-08-03 Luigi Scarso <luigi.scarso@gmail.com>
    *luaharfbuzz: Provide interface for variable fonts (M.Krüger)

2021-07-30 Luigi Scarso <luigi.scarso@gmail.com>
    *patch for luamplib  to process string with "char 0"; fixed also mplib_text 

2021-07-30 Luigi Scarso <luigi.scarso@gmail.com>
    *patch for luamplib  to process string with "char 0"

2021-07-27 Luigi Scarso <luigi.scarso@gmail.com>
    *partoken primitives (HH & PO)

2021-07-27 Luigi Scarso <luigi.scarso@gmail.com>
    *Sync with TeX Live revision 60088.

2021-07-27 Luigi Scarso <luigi.scarso@gmail.com>
    *automake-1.16.4; initialize limit to avoid printing some garbage.

2021-07-02 Luigi Scarso <luigi.scarso@gmail.com>
    *ePNG /Smask for  pdf 2.0

2021-07-02 Luigi Scarso <luigi.scarso@gmail.com>
    *sync with upstream texlive; autoconf-2.71.

2021-05-10 Luigi Scarso <luigi.scarso@gmail.com>
    *MetaPost: fixed the patch on the stack overflow.

2021-05-09 Luigi Scarso <luigi.scarso@gmail.com>
    *Impose mp->stack_size < 1001 in @d push_input to avoid 
     stack overflow due infinite recursion of macro expansion (thanks to A. Kakuto).

2021-04-21 Luigi Scarso <luigi.scarso@gmail.com>
    *\discretionaryligaturemode: optionally block select disc creation 
    (see [Dev-luatex] [PATCH] Nested discretionaries M.F. Krüger) (HH)

2021-04-19 Luigi Scarso <luigi.scarso@gmail.com>
    *\mathdefaultsmode: different radical style defaults 
     (see [Dev-luatex] Uunderdelimiter & friends and mathstyles by M.F. Krüger) (HH)

2021-04-19 Luigi Scarso <luigi.scarso@gmail.com>
    * A patch for  linkarea in rtl context

2021-04-10 Luigi Scarso <luigi.scarso@gmail.com>
    * LuaTeX version 1.13.2  with MetaPost 2.01. 
      The version change in MetaPost 
      is due solely to the bug fix in btex .. etex 

2021-04-02 Luigi Scarso <luigi.scarso@gmail.com>
    * LuaTeX version 1.13.1,  
      The version change is due solely to the bug fix in btex .. etex 

2021-03-28  Luigi Scarso <luigi.scarso@gmail.com>
    * also accept par in math after halign 
      and eqn when in supress mode (HH)

2021-03-23 Karl Berry <karl@tug.org>
    * TL'21.

2021-03-12 Luigi Scarso <luigi.scarso@gmail.com>
    * When restricted system commands is enabled  os.setenv has no effect
    * Patched  Decompress to avoid execution of arbitrary commands

2021-03-07 Luigi Scarso <luigi.scarso@gmail.com>
    * Fixed inclusion of  PDF images with page /Metadata streams (M.F. Krüger)

2021-02-14 Luigi Scarso <luigi.scarso@gmail.com>
    * callback for nesting level used in tracingmacros

2021-02-01 Luigi Scarso <luigi.scarso@gmail.com>
    * two TeX January 2021 DEK buglet fixes (H.Hagen)

2021-01-31 Luigi Scarso <luigi.scarso@gmail.com>
    * mark math glyphs as protected (in order to prevent processing
      as text in base mode) (H.Hagen)
    * removed width/ic compensation for traditional math code path
      (see [Dev-luatex] Duplicated italic correction in do_delimiter ) (H.Hagen)

2021-01-30 Luigi Scarso <luigi.scarso@gmail.com>
    * level_max and level_chr determing what gets put in front of
      macro tracing lines (variant on suggestion by PO on implementors list)(H. Hagen)

2021-01-13 Luigi Scarso <luigi.scarso@gmail.com>
    * pdftex compatibility hack (H. Hagen)

2020-12-13 Luigi Scarso <luigi.scarso@gmail.com>
    * fixed Hyphenation issue regarding frozen glyph nodes (M.F. Krüger)

2020-12-12 Luigi Scarso <luigi.scarso@gmail.com>
    * fixed  luatex segfault with huge romannumeral overfull (H. Hagen)
    * automake (GNU automake) 1.16.3

2020-11-08 Luigi Scarso <luigi.scarso@gmail.com>
    * convert assert(is_simple_character(wordstart)) to tex error

2020-10-30 Luigi Scarso <luigi.scarso@gmail.com>
    * fixed a typo in w32 code in errors.c (A. Kakuto)

2020-10-04 Luigi Scarso <luigi.scarso@gmail.com>
    * fixed a typo in ChangeLog (thanks to A. Kakuto)

2020-10-04 Luigi Scarso <luigi.scarso@gmail.com>
    * patch for openin_any = p (A. Kakuto)

2020-10-04 Luigi Scarso <luigi.scarso@gmail.com>
    * Lua 5.3.6

2020-08-21 Luigi Scarso <luigi.scarso@gmail.com>
    * fixed a couple of bugs in metapost (see ChangeLog).

2020-07-26 Luigi Scarso <luigi.scarso@gmail.com>
    * fixed: \tracinglostchars>=3 is an error (no fatal error)

2020-07-26 Luigi Scarso <luigi.scarso@gmail.com>
    * New value for \tracinglostchars: \tracinglostchars>=3 is a fatal error

2020-07-12 Luigi Scarso <luigi.scarso@gmail.com>
    * Original reports:
     https://tex.stackexchange.com/questions/551313/
     https://tug.org/pipermail/tex-live/2020-June/045876.html
 
    This will probably be fixed by DEK in the 2021 tuneup in a different
    way (so we'll have to remove or alter this change), but the interaction
    sequence in the reports above causes a segmentation fault in web2c -
    writing to the closed \write15 stream because we wrongly decrement
    selector from 16 to 15 in term_input, due to the lack of this check in
    recursive error() call (K. Berry)


2020-07-04 Luigi Scarso <luigi.scarso@gmail.com>
    * little endian variants for readers. (HH)
    * The keyword \type {norule} will hide the rule with the above variants while
      keeping the rule related spacing.  (HH)

2020-06-21 Luigi Scarso <luigi.scarso@gmail.com>
    * pending better is_defined check plus an extra option in a scanner; also the \cs case. (HH)
    * tex.getmark(what,wherefrom)  added (HH)

2020-05-01 Luigi Scarso <luigi.scarso@gmail.com>
    * added tex.interlinepenalties tex.clubpenalties tex.widowpenalties 
    tex.displaywidowpenalties to complement tex.parshape (HH)

2020-04-28 Luigi Scarso <luigi.scarso@gmail.com>
    * less strict lastnode testing (HH) 
    * some experimental math delimiter code removed (HH)

2020-04-27 Luigi Scarso <luigi.scarso@gmail.com>
    * similar treatment for shiftdown as shiftup in operators (no
     checking) (HH)

2020-04-07 Luigi Scarso <luigi.scarso@gmail.com>
    * Version 1.13.0. 
      getstring extra argument to pdfe.getstring (triggers unencoded or flag
      return values) (HH).

2020-03-09 Luigi Scarso <luigi.scarso@gmail.com>
    * texluahb / texluahbjit for luahbtex / luajithbtex

2020-03-09 Luigi Scarso <luigi.scarso@gmail.com>
    * --shell-restricted now forbids loading of dso (dll/so object)

2020-03-09 Luigi Scarso <luigi.scarso@gmail.com>
    * append_vlist : node|nil [prevdepth] (fix + extension/warning) (HH)

2020-03-01 Luigi Scarso <luigi.scarso@gmail.com>
    * fixed lua stack overflow in run_put_next (M. Kruger)

2020-02-29 Luigi Scarso <luigi.scarso@gmail.com>
    * luahbtex: add (single codepoint) "add" method to buffer (M.Kruger)

2020-03-06  Karl Berry  <karl@tug.org>

    * am/luatex.am (texlua[jit][c]) [LUA[JIT]HBTEX && !LUA[JIT]TEX]:
    keep these as links to base lua[jit]tex, not overwriting
    with links to luahb[jit]tex, unless the base luatex is not installed.
    https://tug.org/pipermail/tex-live/2020-March/044948.html
    (and preceding)

2020-02-12  Luigi Scarso <luigi.scarso@gmail.com>
    * restore state for \input delimited with {}

2020-02-11  Luigi Scarso <luigi.scarso@gmail.com>
    * patches for -fno-common (thanks to D. Seifert of Gentoo team)


2020-01-25  Luigi Scarso <luigi.scarso@gmail.com>
    * sync with upstream pplib 
    * sync with upstream luaharfbuzz 


2020-01-11  Luigi Scarso <luigi.scarso@gmail.com>
    * shape fix (HH)

2020-01-03  Luigi Scarso <luigi.scarso@gmail.com>
    * luatex 1.12.0: updated to pplib 2.0

2020-01-02  Luigi Scarso <luigi.scarso@gmail.com>
    * better separation between luatex and luahbtex at build time


2019-12-31  Luigi Scarso <luigi.scarso@gmail.com>
    * scaled virtual font (HH)


2019-12-19  Luigi Scarso <luigi.scarso@gmail.com>
    * fixed inclusion of pdf files with a invalid pageDict (exit, don't load it)


2019-12-11  Luigi Scarso <luigi.scarso@gmail.com>
    * add catcode table check to set_macro (HH)


2019-12-05  Luigi Scarso <luigi.scarso@gmail.com>
    * two fixes for lua user nodes (error report of Sigitas Tolusis <sigitas@vtex.lt> )


2019-11-08  Luigi Scarso <luigi.scarso@gmail.com>
    * record a few more files (in kpse enabled mode) (HH)
    * better recorder code in wrapped lua

2019-11-05  Luigi Scarso <luigi.scarso@gmail.com>
    * fixed calculation of  if (abs(fit_class - fitness(r)) > 1)
      in lineabreak.c (thanks to M. Krüger). This produced different
      results in Windows and Linux.


2019-10-31  Luigi Scarso <luigi.scarso@gmail.com>
    * subfont key in font table (to identify subfint in ttc) plus
      some cleanup (HH)

2019-10-28 Luigi Scarso <luigi.scarso@gmail.com>
    * New callback lua.getcodepage()  for diagnostic purposes.


2019-10-25 Luigi Scarso <luigi.scarso@gmail.com>
    * Also support {oeps.foo} filenames in openin/out


2019-10-22 Luigi Scarso <luigi.scarso@gmail.com>
    *  *** DROPPED  "page_objnum_provider" callback , replaced with "page_order_index" ***


2019-10-18 Luigi Scarso <luigi.scarso@gmail.com>
	* following https://tug.org/pipermail/tlbuild/2019q3/004553.html
          we have now define(__sparc)

2019-10-13 Luigi Scarso <luigi.scarso@gmail.com>
	* additional primitives  \eTeXglue[stretch|shrink]order for querying order the etex way (HH)
	* extra features runtoks (HH)
	* tex.getmodenames() (as these can differ per engine/version) (HH)
	* permit nested runtoks in more complex situations of nesting (HH)
	* more accurate and correct test for tex.[set|get]math
	* minor clean-up and bugs fixed



2019-08-12 Luigi Scarso <luigi.scarso@gmail.com>
	* Support new option --cnf-line from  kapthsea.


2019-07-27 Luigi Scarso <luigi.scarso@gmail.com>
	* Fixed \opein, to be consistent with pdftex in opening
	  a file without extension (but not enclosed in {})

2019-07-06 Luigi Scarso <luigi.scarso@gmail.com>
	* Integration of harfbuzz. 
	* Splitting of exe into *hbtex variants.

2019-02-19 Luigi Scarso <luigi.scarso@gmail.com>
	* am/luatex.am ([un]install-lua[jit]tex-links) [MINGW32]:
	different commands for mingw.

2018-08-27 Luigi Scarso <luigi.scarso@gmail.com>
	* dropped dependency from gmp and mpfr


2017-11-02 Luigi Scarso <luigi.scarso@gmail.com>
	LuaFilesystem 1.7.0

2017-10-03  Luigi Scarso <luigi.scarso@gmail.com>
	A not exhaustive list of changes:

	* luaffi/: Fix to compile with gcc 7.1, 
	patch for callbacks.
	* lpeg/: version 1.0.1

	* luatex.c: We conform to the way Web2c does handle trailing tabs and spaces. This
	decade old behaviour was changed in September 2017 and can introduce
	compatibility issues in existing workflows. Because we don't want too
	many differences with upstream TeXlive we just follow up on that patch
	and it's up to macro packages to deal with possible issues (which can be
	done via the usual callbacks. One can wonder why we then still prune
	spaces but we leave that to the reader.

	* option to set exit code (status.setexitcode) (HH). Changed paths:
	luatexdir/tex/errors.h, luatexdir/tex/errors.w

	* missing_glyph callback (HH). Changed paths:
	luatexdir/font/texfont.h, luatexdir/font/texfont.w,luatexdir/lua/lcallbacklib.c
	luatexdir/luatexcallbackids.h, 	luatexdir/pdf/pdffont.w, luatexdir/pdf/pdfglyph.w;

	* \mathdelimitersmode (see manual) (HH). Changed paths:
	luatexdir/tex/mlist.w, luatexdir/tex/texnodes.h

	* fixes in protect/unprotect and list support in set/getglue (HH). Changed paths:
	luatexdir/lua/lnodelib.c

	* 'class' string in pdf vf command optional (HH). Changed paths:
	luatexdir/font/luafont.w

	* cleanup expansion (HH). Changed paths:
	luatexdir/font/luafont.w, luatexdir/font/texfont.h, luatexdir/font/texfont.w
	luatexdir/lua/lfontlib.c, luatexdir/lua/luatex-api.h, luatexdir/tex/dumpdata.w

	* possibly better fix for extended font embedding (HH). Changed paths:
	luatexdir/font/writefont.w

	* protect_glyphs accepts range and also made consistent with manual (HH). Changed path:
	luatexdir/lua/lnodelib.c

	* some more control over syntex fields (HH). Changed paths:
	luatexdir/tex/texnodes.w

	* fix for neg display skips (HH). Changed paths:
	luatexdir/tex/texmath.w

	* \breakafterdirmode (value 1 will honor glue breaks after a dir node) (HH). Changed paths:
	luatexdir/tex/commands.w, luatexdir/tex/dumpdata.w, luatexdir/tex/equivalents.h,
	luatexdir/tex/linebreak.w, luatexdir/tex/texnodes.h

	* fix width array of extended font (shared with normal)(HH). Changed paths:
	luatexdir/font/writefont.w



2017-02-07  Luigi Scarso <luigi.scarso@gmail.com>

	* luaffi/: First attempt to implement the ffi module in lua
	compatible with the ffi module of luajit.


2015-11-01  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* luatex.c: Improve a little (w32 only).

2015-10-31  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* tex/inputstack.w: Sync with the upstream.

2015-10-13  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* tex/mlist.w: Sync with the upstream.

2015-10-09  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* luatex.c: Sync with the upstream.
	* font/luatexfont.h, font/writetype2.w: Sync with the upstream.

2015-10-08  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* lua/lepdflib.cc, tex/texnodes.h, tex/texnodes.w, NEWS:
	Sync with the upstream.
	* luatex.c: beta-0.81.0.

2015-10-07  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/libluatex.am, am/luafontforge.am: Rearrange to compile the
	luafontloader/src/* files as part of liblua(jit)tex.a, such that
	there is only one libff.a used for LuaTeX and LuaJITTeX.

2015-10-07  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* Sync with the upstream trunk.
	* image/epdf.h: Support Visual Studio 2010 for log().

2015-10-05  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* Completely sync with the upstream trunk.
	Changed files are
	font/writecff.w, font/writefont.w,
	lua/lnodelib.c, lua/lpdflib.c, lua/luatoken.w,
	luafontloader/fontforge/fontforge/lookups.c,
	luafontloader/fontforge/fontforge/parsettf.c,
	luafontloader/fontforge/fontforge/parsettfatt.c,
	luafontloader/fontforge/fontforge/splinefont.h,
	luafontloader/fontforge/fontforge/tottf.c,
	luafontloader/src/luafflib.c,
	luatex.c,
	tex/commands.w, tex/dumpdata.w, tex/equivalents.h, tex/filename.w,
	tex/maincontrol.w, tex/printing.w, tex/texmath.w.

2015-10-01  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdf/pdfgen.w: Sync with the upstream trunk.

2015-09-01  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/lepdflib.cc: Drop useless casts 'const char *' -> 'char *'
	when poppler has Object::initCmd(const char*).

2015-08-31  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/lepdflib.cc: Bugfix: m_Object_dictAdd() must use a copy of
	the Lua string s, otherwise m_Dict_remove() would destroy it.

2015-08-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* image/epdf.h, lua/lepdflib.cc: Drop HAVE_STRUCTTREEROOT_H,
	we now require poppler 0.30 better.
	
2015-08-28  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/libluatex.am: Enable g++ warnings.
	* image/epdf.h, image/pdftoepdf.w, lua/lepdflib.cc: Avoid most
	g++ warnings.

2015-08-27  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* image/pdftoepdf.w: Drop useless casts to avoid warnings.
	* lua/lpdfscannerlib.cc: Unconstify Token.string to avoid warning.
	* lua/lepdflib.cc: Drop useless casts to avoid some warnings.

2015-08-27  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* tex/mlist.w: Sync with the trunk.
	See http://tug.org/pipermail/luatex/2015-August/005319.html
	* tex/printing.w: Do not write to a log file for the
	--[no-]parse-first-line option, since the option actually does not
	exist in lua(jit)tex, although superficially it remains for compatibility
	with existing scripts etc.

2015-07-10  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/luatex.am: Dependencies for 'make check'.

2015-07-03  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/lkpselib.c: Also used for MFLua and MFLuaJIT.

2015-03-31  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luazip/src/luazip.c (zip_close): Sync with the upstream.

2015-03-19 Luigi Scarso <luigi.scarso@gmail.com>

	New library newtokenlib; several bugs fixed.

2015-01-14 Luigi Scarso <luigi.scarso@gmail.com>

	tex/mlist.w: mlist_to_hlist(pointer mlist, boolean penalties, int cur_style)
	HH-LS: was cur_mu = x_over_n(get_math_quad(cur_size), 18);
	This is an old bug so the fix can influence outcome       
	The current mu is instead
	cur_mu = x_over_n(get_math_quad(cur_style), 18);
	Thanks to joseph.wright <joseph.wright@morningstar2.co.uk>

2014-12-21  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* lua/lnodelib.c: Sync with the upstream. Luigi fixes 'print' for
	alink(n) when n is an attribute node.

2014-12-20  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* tex/texnodes.w: Sync with the upstream. Luigi makes minor changes.

2014-12-18  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* tex/texnodes.w: Sync with the upstream. Luigi makes minor changes.

2014-12-17  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* tex/texnodes.w: Sync with the upstream.
	Luigi fixes a bug on cached attributes.

2014-12-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Avoid implicit function declarations.
	* am/luafontforge.am (libjitff_a_CPPFLAGS): Add -DLuajitTeX.
	* am/luamisc.am (libluajitmisc_a_CPPFLAGS: Add -DLuajitTeX.
	* lua/liolibext.c, lua/lnodelib.c, luafontloader/src/luafflib.c,
	slnunicode/slnunico.c: Include lauxlib_bridge.h for LuaJITTeX or
	lauxlib.h for LuaTeX.
	* luafontloader/fontforge/fontforge/fontviewbase.c:
	Include gfile.h.	

2014-12-10  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Sync with https://foundry.supelec.fr/svn/luatex/trunk/source/
	                  texk/web2c/luatexdir/ r5092.

2014-11-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatex.c: Avoid MinGW64 warnings (INVALID_SOCKET => -1).

2014-11-03  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* luatex.c: Indentation.

2014-10-31  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatex.[ch] [W32TEX]: Handle DLLPROC as for TeX & Co.
	* am/luatex.am: Define LuajitTeX.

2014-10-13  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatex.[ch]: More sync with ../texmfmp.h and ../lib/texmfmp.c.

2014-10-09  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatex.c: Apply some code from W32TeX.

2014-10-08  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatex.c: Sync with some recent changes in ../lib/texmfmp.c
	(and luatexfirst.c from W32TeX).

2014-09-16  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/luatex.am: Factor out common *_LDADD and *_DEPENDENCIES.

2014-08-19  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* image/writepng.w: Avoid PNG warnings.

2014-07-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* image/epdf.h, lua/lepdflib.cc: Use code for poppler >= 0.25
	with <StructTreeRoot.h> or code for poppler <= 0.24 without.
	* fake/StructTreeRoot.h (removed): Obsolete.
	* am/libluatex.am: Adapted.

2014-07-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luasocket/src/wsocket.h: Avoid redefinition of _WIN32_WINNT.

2014-07-11  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/libluatex.am: Compiling liblua(jit)tex.a requires mplib.h;
	add libmplib.a as dependency.

2014-06-20  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/libluatex.am: Remove ../mplibdir/lmplib.c from sources and
	dependency on libmplib.a.
	* am/luatex.am: Add ../mplibdir/lmplib.c to sources, dependency
	on libmplib.a, and -DpdfTeX to CPPFLAGS.

	* am/luatex.am: Adapt to MetaPost 1.999 (libgmp and libmpfr).

2014-06-19  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* font/mapfile.w, font/tounicode.w, font/writet1.w,
	font/writettf.w, lang/texlang.w, pdf/pdfgen.w: Avoid undefined
	behaviour when char is signed.

2014-06-02  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/luatex-api.h: Use '#define LUAI_HASHLIMIT 5' as default,
	as in ../../libs/lua52/lua-5.2.3/src/lstring.c and in
	../../libs/luajit/LuaJIT-2.0.3/src/lj_str.c.
	* lua/lstatslib.c, tex/printing.w: Use LUAI_HASHLIMIT instead of
	LUATEX_HASHCHARS and LUAJITTEX_HASHCHARS.

	* lua/luatex-api.h: Define MyName as "LuajitTeX"/"LuaTeX" and
	my_name as "luajittex"/"luatex".
	* lua/luainit.w, luatex.c, tex/printing.w: Use MyName, my_name.

2014-05-14  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* tex/filename.w: Avoid redefinition of promptfilenamehelpmsg,
	(re)use definition in ../cpascal.h.

2014-05-13  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* tex/filename.w: Print the usual TeX promptfilenamehelpmsg also
	in lua(jit)tex.

2014-04-10  Taco Hoekwater  <taco@luatex.org>

	* luatex.c: hardwire the compilation date, preventing the 
	luatex binary from constantly changing after recompilation

2014-03-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdf/pdfgen.[hw]: Declare get_pdf_table_string() as
	'static const char *'.

2014-03-29  Taco Hoekwater  <taco@luatex.org>

	Import LuaTeX 0.79.1 from LuaTeX repository (released)

2014-03-28  Taco Hoekwater  <taco@luatex.org>

	Import LuaTeX 0.79.0 from LuaTeX repository (released)

2014-03-15  Taco Hoekwater  <taco@luatex.org>

	Import LuaTeX snapshot 0.79.0 from LuaTeX repository (r4903).

2014-02-10  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* lua/luatex-api.h: MSC version has luaopen_bit32() in dll.

2014-02-07  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/luatex-api.h: Declare luaopen_bit32();

2014-02-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/libluatex.am, am/luafontforge.am, am/luamisc.am,
	am/luasocket.am, am/luatex.am: Add rules for LuaJITTeX.

	* luajittex.test, luajitimage.test: New tests for LuaJITTeX.

	Avoid compiler warnings.
	* lua/liolibext.c, lua/luajitstuff.w: Drop compilation of
	unused static functions.  Avoid to compute unused value.
	* lua/texluajitc.w: Include header for luac_main() prototype.
	* lua/luatex-api.h: Drop duplicate luac_main() prototype.

2014-02-04  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* lua/luainit.w: Change a little for LuaJITTeX.

2014-02-01  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Import LuaTeX snapshot 0.78.3 from LuaTeX repository (r4772).

	* luatexfont.h: Keep the prototype for auto_expand_font() as
	long as the function remains in vfovf.w.

	* liolibext.c [__MINGW32__]: Don't redefine l_fseek etc.

2014-02-01  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/libluatex.am, am/luafontforge.am, am/luamisc.am,
	am/luasocket.am, am/luatex.am: Prepare for LuaJITTeX.

2014-01-31  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* tex/printing.w (print_cs): Bug fix from TeX 3.14159265.

2014-01-02  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* image/writepng.w: Allow libpng >= 1.6.3 to read images with
	incorrect CMF bytes.

2013-12-23  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdf/pdfgen.w (pdf_end_stream): Always write "\nendstream" for
	PDF/A-1b compliance.

2013-12-19  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* lua/liolibext.c: Large files in lua.

2013-12-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* image/epdf.h, lua/lepdflib.cc: Adapt for poppler-0.25.x.
	* fake/StructTreeRoot.h (new): Provide 0.24.4 compatibility.
	* am/libluatex.am: Adapted.

2013-12-08  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* font/writet3.w: More cast arg2 of setpdffloat to int64_t.
	* pdf/pdfpage.w: Fix i32round() => i64round().

2013-12-07  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* lua/liolibext.c: Large files in lua.

2013-12-07  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Fix a serious bug related to large numbers in pdfimages.
	Mail from Akira Kakuto <kakuto@fuk.kindai.ac.jp>, 6 Dec 2013.
	* pdf/pdftypes.h: Change pdffloat.m from long to int64_t.
	Define i32round(a) and i64round(a) instead of lround(a).
	* font/writet3.w: Cast arg2 of setpdffloat to int64_t.
	* image/writejp2.w: Use uint64_t instead of unsigned long long.
	* image/pdftoepdf.w, pdf/pdfgen.w, pdf/pdfglyph.w,
	pdf/pdfimage.w, pdf/pdfpage.w, pdf/pdfrule.w: Replace lround(a)
	by i32round(a) or i64round(a).

2013-09-20  Karl Berry  <karl@tug.org>

	* lua/luainit.w (lua_initialize) [NATIVE_TEXLIVE_BUILD]: omit date.
	* tex/printing.w (print_banner) [NATIVE_TEXLIVE_BUILD]: replace
	date with WEB2CVERSION for TL binaries.

2013-08-06  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* font/writecff.w: Fix a bug in write_cid_cff(). There was not
	pdf_end_dict() for the corresponding pdf_begin_dict().

2013-07-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* font/writettf.w: Treat unknown 'post' table versions
	(found in some broken fonts) as 3.0, i.e., no Glyph names.

2013-07-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/luatex.am, tests/luaimage.tex: Add a .pdf image.

2013-07-05  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdf/pdfgen.w: Use "%"LONGINTEGER_PRI"d" format specifier to
	print (LONGINTEGER_TYPE) casted longinteger and off_t variables.

2013-07-05  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/luainit.w (init_kpse, lua_initialize):
	Use kpse_program_basename().

2013-07-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luaimage.test, tests/luaimage.tex: New test and data.
	* am/luatex.am: Add the new test.

2013-07-02  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* luatex.c : Replace lines between "#if defined (TeX) && defined (IPC)"
	and "#endif /* TeX && IPC */" with those in texmfmp.c.

2013-07-01  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* luatex.c, ptexlib.h: Revert the previous change.
	* luatex.c [MSVC]: Undef timezone before including <time.h>.

2013-06-28  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* luatex.c, ptexlib.h: Slightly modify because Visual Studio cannot
	compile luatex.c.

2013-06-28  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/lcallbacklib.c, lua/luainit.w: Replace index() => strchr().

	* ptexlib.h: More general cases for not been included first.

	* lang/hyphen.h: Do not '#include "ptexlib.h"'.
	* lang/hyphen.w: Include ptexlib.h instead of lang/hyphen.h.

2013-06-28  Karl Berry  <karl@tug.org>

	* ptexlib.h: complain if various common things are #defined;
	this must be the first #include.

2013-06-27  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Bug fix for LuaTeX crash on 32bit Unix systems from Taco,
	tlbuild mail 26 Jun 2013 16:10:35,
	http://tug.org/pipermail/tex-live/2013-June/033782.html
	* image/writejbig2.w, image/writejp2.w, image/writejpg.w,
	image/writepng.w: Always first include ptexlib.h.

2013-06-26  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/libluatex.am, am/luasocket.am, am/luatex.am:
	Correct dependencies for build `on demand'.

2013-06-19  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua52/: Moved to ../../../libs/lua52/.
	* am/libluatex.am: Adapted.
	* am/liblua52.am: Removed.

2013-06-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* image/epdf.h, image/writeimg.w, lua/limglib.c,
	lua/lpdfscannerlib.cc, lua/lstrlibext.c, lua/luatex-api.h,
	lua/texluac.w, ptexlib.h: Replace 'lua52/lua.h' => 'lua.h'.

2013-06-02  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/lpdfscannerlib.cc: Include <poppler-config.h> instead of
	<poppler/poppler-config.h>.

2013-04-16  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/luainit.w: Handle '--luac' and '--luaconly' (from Akira).

2013-04-16  Elie Roux  <elie.roux@telecom-bretagne.eu>

	* font/tfmofm.w: check for .ofm as well as .tfm.
	* tex/mainbody.w: check for !ini_version before initialize().

2013-04-16  Karl Berry  <karl@tug.org>

	* lua/luainit.w (parse_options): GPLv2+, not just GPLv2 (after
	discussion with Taco).

2013-04-14  Karl Berry  <karl@tug.org>

	* lua/luainit.w: 2013

2013-04-08  Taco Hoekwater  <taco@luatex.org>

	* luasocket/src/smtp.lua: uncomment require 'coroutine'
	* luasocket/src/smtp_lua.c: regenerated

2013-04-05  Taco Hoekwater  <taco@luatex.org>

	Import luatex beta 0.76.0 (released version)

2013-04-04  Karl Berry  <karl@tug.org>

	* lua52/liolib.c: #include <unistd.h>.  Needed on FreeBSD
	per Nikola Lecic, tlbuild 1 Apr 2013 02:10:08.

2013-03-21  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Import LuaTeX beta-0.75.0 from LuaTeX repository (r4604).

2013-03-20  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/luafontforge.am (EXTRA_DIST): Drop unused files.

2013-03-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua52/*, am/liblua52.am (new): Add lua-5.2.1 for 0.75.0.

2013-01-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/luatex.am: Allow subdir-objects.

2013-01-19  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdf/pdftables.h: Support large files (from Martin).

2013-01-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatex.c (mk_shellcmdlist): Simplify (sync with texmfmp.c).

2013-01-10  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdf/pdfgen.w (write_stream_length): Cast length for printing.

2012-12-16  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/libluatex.am (luatex_*_ctangle, pdflua.c):
	Enable silent rules.

2012-11-20  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/lkpselib.c: Use kpse_readable_file() with non-const arg.

2012-11-20  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/lepdflib.cc: No need to test for Annot::decRefCnt with
	poppler 0.18 or better.

2012-11-06  Akira Kakuto  <kakuto@fuk.kinidai.ac.jp>

	* pdf/pdflistout.w: sync with r4471 (a bug fix by H. Henkel).

2012-10-13  Akira Kakuto  <kakuto@fuk.kinidai.ac.jp>

	* tex/texfileio.w: input by pipe was impossible. enable it.

2012-10-11  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/luainit.w (lua_initialize): Free two malloc()ed strings.

2012-10-10  Akira Kakuto  <kakuto@fuk.kinidai.ac.jp>

	* luatex.c: Modify determination of fullpath for restricted shell
	escape commands.

2012-10-10  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Avoid TL vs W32TeX differences (from Akira).
	* luatex.h: Include "ptexlib.h" instead of <luatexdir/ptexlib.h>
	as in all other cases.
	* ptexlib.h: Use _MSC_VER instead of MSVC.
	* image/epdf.h: Change arg3 of extern void pdf_begin_obj() from
	bool to int, as declared and defined in pdf/pdfgen.[hw].
	FIXME: There should be only one extern declaration in one file.

2012-10-09  Peter Breitenlohner  <peb@mppmu.mpg.de>

	The openbsd compat library is no longer used.
	* image/epdf.h, lua/luainit.w, ptexlib.h, utils/utils.w:
	Drop #include "openbsd-compat.h".
	* am/libluatex.am, am/luatex.am: Remove OBSDCOMPAT_*.

2012-09-19  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/luainit.w (parse_options): Avoid cast const => non-const.

2012-09-13  Akira Kakuto  <kakuto@fuk.kinidai.ac.jp>

	* lua/luainit.w (parse_options): allow lualatex "\input" "a b" on
	Windows.

2012-09-08  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatex-api.h: Avoid conflicting extern declaration of environ,
	declared in <stdlib.h> for WIN32 (from W32TeX).

2012-08-21  Akira Kakuto  <kakuto@fuk.kinidai.ac.jp>

	* tex/texdeffont.w (tex_def_font): Recover the old code, because the
	new code seems not to work.

2012-08-10  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* ptexlib.h: Drop unused definition of M_PI.

2012-08-07  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* tex/dumpdata.h: Remove the swap_items() prototype.
	* luatex.c (swap_items): Moved from here ...
	* tex/texfileio.w (swap_items): ... to here and declared static.

	* luatex.c (input_line) [WIN32]: Sync with ../lib/texmfmp.c.
	Detect and skip Byte order marks.
	* tex/texfileio.[ch] [WIN32]: Use Poptr to record pipe input.

2012-08-03  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatex.[ch] [W32TeX]: Use DLLPROC for luatex.dll.
	* pdf/pdfgen.w [WIN32]: Convert file names '\\' -> '/'.

2012-08-02  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* tex/texdeffont.w (tex_def_font): Better tracing of font
	definitions, adapted from e-TeX version 2.5.

2012-07-31  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdf/pdfpage.w (print_pdffloat): Cope with broken snprintf().
	* lua/luastuff.w (luatex_error): Drop snprintf() return value.

2012-07-28  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/luainit.w (lua_initialize): Avoid using asprintf().
	* utils/utils.w (initversionstring): Avoid using asprintf().

	One and only one prototype per function.
	* image/epdf.h, utils/utils.h: Add #include "luatex-common.h"
	and move pdftex_{fail,warn} prototypes from here ...
	* luatex-common.h (new): ... to here.
	* am/libluatex.am (libluatex_a_SOURCES): Add the new file.

2012-07-26  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/loslibext.c os_gettimeofday): Use int64_t (from W32TeX).

2012-07-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* image/pdftoepdf.cc (get_file_checksum): Use uint64_t and PRIu64.
	* image/writejp2.w, lua/loslibext.c: Use uint64_t.

2012-07-23  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* tex/texfileio.w (runpopen): Sync with ../lib/texmfmp.c.

2012-07-19  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* image/writejbig2.w: Use LONGINTEGER_PRI, not LONGINTEGER_PRId.
	* pdf/pdfgen.w: Use LONGINTEGER_PRI, not LONGINTEGER_PRIi.

2012-07-14  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* utils/utils.w: Use EXIT_FAILURE instead of EX_SOFTWARE.

2012-07-13  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdf/pdfgen.w: Cast xfseeko() arg2 to avoid MSVC warning.

2012-07-09  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* tex/texfileio.w (runpopen): Sync with ../lib/texmfmp.c.

2012-07-07  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatex.c (shell_cmd_is_allowed): Change Arg1 from 'const char **'
	into 'const char *'; sync with ../lib/texmfmp.c.
	* luatex.h, lua/liolib.c, lua/loslibext.c, tex/texfileio.w: Adapt.

	* lua/liolib.c, luascripts/txt2zlib.w: Use binary file io mode.
	From Akira Kakuto <kakuto@fuk.kindai.ac.jp> (W32TeX).

2012-05-22  Taco Hoekwater  <taco@luatex.org>

	* lua/lkpselib.c: new function kpse.default_texmfcnf() that
	reports the value of DEFAULT_TEXMFCNF, for the benefit of
	context mkiv on Debian.

2012-05-22  Taco Hoekwater  <taco@luatex.org>

	* luafontloader/fontforge/fontforge/splinesave.c,
	luafontloader/fontforge/fontforge/splinefont.h: drop parts of the
	Type1 saving routines (unused) to remove a compiler warning.

	* pdf/pdftypes.h, lua/limglib.c, image/epdf.h, image/writeimg.w,
	image/writejbig2.w, ptexlib.h: more off_t trouble.

2012-05-21  Taco Hoekwater  <taco@luatex.org>

	* tex/printing.w, lua/ltokenlib.c, lua/llanglib.c, lua/llualib.c,
	lua/lnodelib.c, lua/luainit.w, lua/ltexiolib.c,
	lua/lcallbacklib.c, lua/lstatslib.c, lua/ltexlib.c,
	lua/loslibext.c, lua/lkpselib.c, lua/luatoken.w, lua/llfslibext.c,
	lua/lfontlib.c, lua/luanode.w, lua/lpdflib.c, lua/luastuff.w:
	when loading both "ptexlib.h" and "lua/luatex-api.h", make sure
	that "ptexlib.h" is loaded first because that reads config.h
	which affects loading of system headers (via Large File Support,
	specifically).

2012-05-20  Khaled Hosny  <khaledhosny@eglug.org>

	* tex/mlist.w: fix "warning: 'ext' might be used uninitialized".

2012-05-18  Taco Hoekwater  <taco@luatex.org>

	* lua/ltexlib.c: fix a ConTeXt crash on `\endinput \end`.

2012-05-18  Khaled Hosny  <khaledhosny@eglug.org>

	* tex/commands.h, tex/commands.w, tex/maincontrol.h,
	tex/maincontrol.w, tex/mathcodes.h, tex/mathcodes.w, tex/scanning.w, 
	tex/texmath.w, tex/mlist.w: backport math relatex changes from 0.71
	* luatex.c: bump version to 0.70.1

2012-05-10  Hartmut Henkel  <hartmut@luatex.org>
	and Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/lepdflib.cc: Adapt for poppler 0.19.4.

2012-05-09  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/luainit.w (lua_initialize): Use WEB2CVERSION.
	* tex/printing.w (print_banner, log_banner): Same.

2012-02-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatex.h: Remove definition of WRITE_OUT, now in ../cpascal.h.

2012-01-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* image/writejbig2.w (getstreamlen): Change type to `off_t'.
	Use LONGINTEGER_TYPE and LONGINTEGER_PRId for printing.

2012-01-11  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Consistent support for large JBIG2 files.
	* image/writejbig2.w: Change type of various struct members, local
	variables and findstreamstart() from `long' or `unsigned long'
	to `off_t'.  Do not use xfseek and xfseeko for the same file.

2011-10-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/lepdflib.cc: Test poppler 0.16.x / 0.17.x features.

2011-10-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/libluatex.am: Avoid to `clean' ../mplibdir/lmplib.c.

	* am/txt2zlib.am (noinst_PROGRAMS): Conditionally add txt2zlib,
	such that txt2zlib$(EXEEXT) gets cleaned.

2011-09-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* tex/printing.w (print_file_line): Bug fix: avoid uninitialized
	lineno - from ../tex.ch.
	* tex/inputstack.w: Slightly reformulate printing of current
	line - from ../etexdir/etex.ch.

2011-08-04  Magnus Granberg  <zorry@gentoo.org>

	* luatex.c: Do not #include empty file <kpathsea/recorder.h>.

2011-06-17  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Reduce memory leaks.
	* lua/lkpselib.c (do_lua_kpathsea_lookup): Free string no longer
	used.

2011-06-16  Peter Breitenlohner  <peb@mppmu.mpg.de>

	lua/lkpselib.c (find_dpi): Allow find_suffix() to return a
	const string.

2011-05-19  Taco Hoekwater  <taco@luatex.org>

	* lua/ltexlib.c: fix a bug on negative catcode table arguments.
	* luatex.c, NEWS: luatex is now version 0.70.1
	* luatex_svnversion.h: updated to reflect latest luatex revision (4277)

2011-05-18  Taco Hoekwater  <taco@luatex.org>

	* font/writefont.w (write_fontdescriptor):  Fix for non-embedded
	fonts in the PDF output.
	* image/writeimg.w (read_img): Fix for non-existent images that
	could case a crash.
	* luatex_svnversion.h: updated to reflect latest luatex revision (4273)

2011-05-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatex.c (ipcpage): Add 'free(cwd)', remove Aleph comment.

2011-05-17  Taco Hoekwater  <taco@luatex.org>

	* tex/texfileio.w (luatex_synctex_get_current_name): switch to xgetcwd()
	from kpathsea
	* luatex_svnversion.h: updated to reflect latest luatex revision (4272)

2011-05-15  Taco Hoekwater  <taco@luatex.org>

	* tex/texfileio.w (luatex_synctex_get_current_name): work around a 
	bug in getcwd().
	* luatex_svnversion.h: updated to reflect latest luatex revision (4267)

2011-05-13  Taco Hoekwater  <taco@luatex.org>

	* lua/luainit.w: change the copyright year to 2011.
	* luatex_svnversion.h: updated to reflect latest luatex revision (4264)
	* NEWS: forgot to mention synctex change
	
2011-05-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* image/writepng.w: #define PNG_FP_1 for libpng < 1.5.0.

2011-05-11  Taco Hoekwater  <taco@luatex.org>

	* image/writepng.w: fix for 16bit images in pdf 1.4 (8bit) mode.
	* luatex_svnversion.h: updated to reflect latest luatex revision (4258)

2011-05-09  Taco Hoekwater  <taco@luatex.org>

	* tex/texfileio.[hw]: file relative filenames in synctex output.
	* luatex_svnversion.h: updated to reflect latest luatex revision (4256)

2011-05-08  Taco Hoekwater  <taco@luatex.org>

	* dvi/dvigen.w, pdf/pdfgen.w: fix missing newline after
	'No pages of output' message.
	   
2011-05-08  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* lua/luainit.w, tex/texfileio.w: fix recorder location.

2011-05-05  Taco Hoekwater  <taco@luatex.org>

	* image/writepng.w: fixes for libpng 1.5.2.
	* lua/lnodelib.c (lua_nodelib_fields): fix field count for 
	nodes without subtype.
	* lua/llfslibext.c: fix an variable type and a compiler warning.
	* lua/loslibext.c (os_execute): fix non-argument use of os.execute.
	* lua/ltexlib.c (do_luacprint): fix use of bad catcode tables.
	* lua/luainit.w (HAVE_ASPRINTF): superfluous test removed.
	* luatex.c: bump version to 0.70, remove SOCK_NONBLOCK definition.
	* luatex_svnversion.h (luatex_svn_revision): now at 4247.
	* NEWS: updated for luatex 0.70.0 release.
	* tex/texfileio.w: patch from bug 615 (recorder filename location).
	* tex/texmath.w: fix display alignment in TRT mode.
	* utils/utils.w (HAVE_ASPRINTF): superfluous test removed.

2011-04-16  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* utils/synctex{-common.h,.c,.h} (removed): Use copies from
	../synctexdir.
	* synctex-luatex.h: Moved from here to ../../synctexdir.
	* ptexlib.h, am/libluatex.am, am/luatex.am: Adapted. 

2011-04-13  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* utils/utils.w (POPPLER_VERSION): Now defined in
	poppler-config.h for poppler from the TeX Live tree, or in the
	Makefile for an installed version.

2011-04-13  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/libluatex.am, am/txt2zlib.am: When cross compiling skip
	txt2zlib and use installed luascripts/pdflua.c.

	Need poppler at least 0.12 for PDFDoc::getPDF*Version().
	* image/pdftoepdf.cc: Remove code for older poppler versions.

2011-04-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* image/writepng.w: Fix to build with png-1.5 (and avoid
	`deprecated' warnings with png-1.4). The transformations part
	is removed on recommendation by John Bowler (a png developer).
	Mail from Thomas Klausner <tk@giga.or.at>, Sun, 30 Jan 2011.

	* pdf/pdfgen.w: ANSI C function definitions.

	* pdf/pdfluaapi.w (new_pdflua): Declare zp as const.

	* am/libluatex.am (EXTRA_DIST): Distribute luascripts/pdflua.lua.
	* am/txt2zlib.am (EXTRA_DIST): Distribute luascripts/txt2zlib.w.

2011-04-12  Taco Hoekwater  <taco@luatex.org>

	* import of luatex 0.66.0, released version

2011-03-28  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/libluatex.am: Use AM_CFLAGS instead of libluatex_a_CFLAGS.
	* am/luatex.am: Use AM_CFLAGS instead of luatex_CFLAGS.

2011-03-14  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/libluatex.am (libluatex_a_CPPFLAGS): Remove `-Iluatexdir'
	and add `-DSYNCTEX_ENGINE_H='<utils/synctex-luatex.h>''.
	* am/luatex.am (luatex_CPPFLAGS): The same.

	* utils/synctex.c: Fix several typos in comments to reduce diffs
	between files in synctexdir/ and luatexdir/utils/.

2011-02-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/luatex.am [WIN32]: Add texlua.exe and texluac.exe wrappers
	for MinGW.

2010-12-23  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/luatex.am: install-exec-hook and uninstall-hook rules now
	in ../Makefile.am; append required symlinks to bin_links.

2010-09-28  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatex.test (new): Just testing 'luatex -credits'.
	* luatexdir/am/luatex.am: Adjusted.

2010-07-12  Taco Hoekwater <taco@luatex.org>

	* luafontloader/src/luafflib.c: quick fix for crashes triggered
	by invalid panose data in Open/TrueType fonts.
	* luatex_svnversion.h: new version (rev 3736).

2010-07-01  Taco Hoekwater <taco@luatex.org>

	* lang/texlang.w, lua/lnodelib.c, luatex.c, luatex_svnversion.h,
	pdf/pdfglyph.w, pdf/pdfpage.w, NEWS: new versions from released 0.60.2
	
2010-06-18  Taco Hoekwater <taco@luatex.org>

	* tex/textoken.h (smemory_word): add endiannes test
	* font/texfont.h (liginfo, kerninfo): add endianness test
	* luatex_svnversion.h: new version

2010-06-13  Taco Hoekwater <taco@luatex.org>

	* tex/inputstack.h (in_state_record): force two bitfields to be signed,
	after a bug report from Vladimir Volovich <vvv@vsu.ru>
	* luatex_svnversion.h: new version

2010-06-11  Taco Hoekwater <taco@luatex.org>

	* font/sfnt.w, font/sfnt.h, 
	luafontloader/fontforge/Unicode/ucharmap.c,
	luafontloader/fontforge/fontforge/python.c, 
	luafontloader/fontforge/inc/basics.h: change include of "config.h"
	to <w2c/config.h>.
	* image/epdf.h, lua51/luaconf.h: change include of "c-auto.h"
	to <w2c/c-auto.h>.
	
2010-06-10  Taco Hoekwater <taco@luatex.org>

	* luatex.c (swap_items): debugged.
	* tex/texfileio.w (do_zdump): reswap the swapped items to avoid
	crashes when called as |dump_things|.

2010-06-10  Taco Hoekwater <taco@luatex.org>

	* luafilesystem/src/lfs.c(get_dir): do not assume Gnu C compiler.

2010-06-10  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/libluatex.am (libluatex_a_CPPFLAGS): Add $(AM_CPPFLAGS).
	* am/luafontforge.am (libff_a_CPPFLAGS): Add $(AM_CPPFLAGS).
	* am/luatex.am (luatex_CPPFLAGS): Add $(AM_CPPFLAGS).

2010-06-10  Taco Hoekwater <taco@luatex.org>

	* luasocket/src/options.c, luafontloader/fontforge/fontforge/parsettfatt.c,
	luafontloader/fontforge/fontforge/parsettf.c,
	luafontloader/fontforge/fontforge/lookups.c: enlarge static buffers
	for sprintf().
	
2010-06-04  Taco Hoekwater <taco@luatex.org>

	* luatex.c (shell_cmd_is_allowed): make sure only commands with
	absolute path names are executed on win32 in restricted mode --
	patch from Akira Katuto.

2010-05-28  Taco Hoekwater <taco@luatex.org>

	* luamd5/md.5c: bring in a new version from kepler to fix a
	portability problem with stdint.h.
	* luafontloader/src/ffdummies.c, lua/texluac.w: guard __attribute__
	usage, which is a GNUC only feature.
	    
2010-05-19  Taco Hoekwater <taco@luatex.org>

	* printing.w (print_banner, log_banner), luainit.w (lua_initialize):
	add WEB2CVERSION to the banner.

2010-05-13  Taco Hoekwater <taco@luatex.org>

	* utils/synctex.c, utils/synctex-luatex.h: update from Jérôme 
	Laurens, bringing luatex in-line with the core synctex distribution
	* luatex_svnversion.h: updated to reflect the version of 0.60.x branch
	
2010-05-06  Taco Hoekwater <taco@luatex.org>

	* luatex.c (calledit): use ifdef __MINGW32__ instead of WIN32.
	* luatex_svnversion.h: updated to reflect the version of 0.60.x branch

2010-04-28  Taco Hoekwater <taco@luatex.org>

	* tex/maincontrol.w: Fixed the error message for improper 
	use of \protected, reported by Heiko Oberdiek 
	<heiko.oberdiek@googlemail.com>.

2010-04-28  Taco Hoekwater  <taco@luatex>

	* import of luatex 0.60.1, released version

2010-04-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* image/epdf.h, lua51/luaconf.h: #include <c-auto.h> instead of
	<web2c/c-auto.h>.

2010-04-24  Taco Hoekwater  <taco@luatex>

	* lua/loslibext.c: fix os.exec() and os.spawn(), twice

2010-04-23  Taco Hoekwater  <taco@luatex>

	* lua/loslibext.c: fix os.exec() and os.spawn() once more

2010-04-23  Taco Hoekwater  <taco@luatex>

	* lua/loslibext.c: fix os.exec() and os.spawn()
	* luatex_svnversion.h: updated to reflect the version of 0.60.x branch

2010-04-23  Taco Hoekwater  <taco@luatex>

	* new import from luatex repository (HEAD of 0.60.x branch)

2010-04-20  Taco Hoekwater  <taco@luatex>

	* new import from luatex repository (HEAD of 0.60.x branch)

2010-04-13  Taco Hoekwater  <taco@luatex>

	* am/luafontforge.am: delete three lines.
	* luafontloader/fontforge/Unicode/dump.c: deleted
	* luafontloader/fontforge/Unicode/backtrns.c: deleted
	* luafontloader/fontforge/Unicode/unialt.c: deleted

2010-04-13  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* image/pdftoepdf.cc: Fix building with libpoppler.
	* luatex.c: Fix building for MinGW32.

	* luatex.c (ipcpage): Avoid compiler warning.
	(catch_interrupt): Declare as static.
	* pdf/pdflistout.w (init_*_backend_functions): ANSI C func defs.

2010-04-13  Taco Hoekwater  <taco@luatex>

	* new import from luatex repository (HEAD of 0.60.x branch)

2010-04-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/luatex.am: Remove libmplib.a from $($(luatex_OBJECTS)'s
	dependencies ...
	* am/libluatex.am: and add to $(libluatex_a_OBJECTS)'s
	dependencies; otherwise parallel builds may fail.

2010-04-04  Taco Hoekwater  <taco@luatex>

	* import of luatex 0.60.0, with a few local changes:
	* luatex.c (ipcpage): fix fetching of 'name'.
	* dvi/dvigen.w (dvi_end_page): fix IPC flushing.
	* image/pdftoepdf.cc (write_epdf1): comment out use of 
	page->getResourcesNF() and page->getMetadataNF().

2010-03-09  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatangle.ch: Use kpse_set_program_name(argv[0], nil) instead
	of kpse_set_progname(argv[0]).

2010-02-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/luamisc.am (libluamisc_a_CPPFLAGS): Adapt to zziplib now
	in ../../../libs/zziplib/.

2010-01-31  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Moved zziplib/ to ../../../libs/zziplib.
	* am/luamisc.am (libluamisc_a_DEPENDENCIES): Adapt.
	* am/luatex.am (luatex_ldadd): Adapt.

2010-01-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Clarify dependencies between luaTeX libraries:
	* am/libzzip.am: Remove dependency on liblua51.a.
	Remove memdisk.[ch] and mmapped.[ch] from libzzip_a_SOURCES and
	add them to EXTRA_DIST.
	* am/luamisc.am: Add dependency on libzzip.a.
	* am/luasocket.am: Replace dependency on libzzip.a by liblua51.a.

2010-01-27  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* utils/avl.c (avl_copy): Proper handling of const.

2010-01-27  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luafontloader/src/luafflib.h: New file with prototypes used
	by libluatex.
	* luafontloader/src/luafflib.c: #include "luafflib.h".
	* font/writecff.c, font/writetype2.c: Remove the extern decls
	and #include <luafontloader/src/luafflib.h>.
	* font/writecff.c (writetype1w): Change tfm_size integer=>int.
	* am/luafontforge.am: Add the new file.

	* luatex-api.h: Add prototype for utf8_idpb(), renamed
	lua_utf8_idpb to avoid name conflicts with fontforge library.
	* lang/texlang.c: Declare utf8_idpb() as non-static.
	* tex/filename.c: Remove prototype for utf8_idpb().

	* tex/filename.c (scan_file_name): Don't assume a null byte
	after string created by utf8_idpb().

2010-01-26  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* font/writettf.c: Remove extern charsetstr[].
	* lua/lkpselib.c: Remove extern luainit.
	* lua/luainit.c: Remove extern normalize_quotes(), argc, argv.
	* tex/textoken.c: Remove extern insert_vj_template().

	* utils/utils.h: Add extern declaration of fb_array ...
	* font/writet1.c, font/writettf.c: ... removed from here.
	* luatex-api.h: Add extern declaration of program_name_set ...
	* lua/luainit.c, lua/luatex.c: ... removed from here.
	* luatex-api.h: Add extern declaration of startup_filename,
	safer_option, and nosocket_option ...
	* lua/luastuff.c: ... removed from here.
	* lua/llualib.c (luabytecode_max): Change integer=>int.
	* luatex-api.h: Add extern declaration of luabytecode_max,
	luabytecode_bytes, luastate_bytes, callback_count, and
	saved_callback_count ...
	* lstatslib.c: ... removed from here.

2010-01-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/luatex.am (luatex_CFLAGS, luatex_CXXFLAGS),
	am/libluatex.am (libluatex_a_CFLAGS): Enable compiler warnings.

	Avoid most compiler warnings:

	* font/luatexfont.h, luatexdir/hyphen.h, image/writeimg.h,
	image/writejbig2.h, luatex.h, pdf/pagetree.h, pdf/pdfpage.h,
	utils/avlstuff.h, utils/utils.h: ANSI C function prototypes.
	* font/mapfile.c, font/writeenc.c, font/writefont.c,
	font/writet1.c, font/writettf.c, image/writeimg.c,
	image/writejbig2.c, lang/hyphen.c, pdf/pagetree.c,
	pdf/pdfpage.c, utils/avlstuff.c, utils/utils.c: ANSI C function
	definitions.

	* font/luafont.c, lang/texlang.c, lua/lcallbacklib.c,
	lua/lfontlib.c, lua/limglib.c, lua/lkpselib.c, lua/llualib.c,
	lua/lnodelib.c, lua/loslibext.c, lua/lpdflib.c, lua/lstatslib.c,
	lua/ltexiolib.c, lua/ltexlib.c, lua/ltokenlib.c, lua/luanode.c,
	lua/luatoken.c: Remove 'char *' or 'unsigned char *'  casts of
	Lua strings.

	* font/texfont.h, font/writecff.h, luatex-api.h, luatex.h,
	nodes.h, primitive.h, ptexlib.h, utils/utils.h, font/dofont.c,
	font/luafont.c, font/tfmofm.c, font/vfovf.c, font/writecff.c,
	font/writefont.c, font/writet1.c, font/writettf.[ch],
	lang/hyphen.c, lang/texlang.c, lua/lcallbacklib.c,
	lua/lfontlib.c, lua/limglib.c, lua/lkpselib.c, lua/llualib.c,
	lua/lnodelib.c, lua/loslibext.c, lua/lpdflib.c, lua/lstatslib.c,
	lua/ltexiolib.c, lua/ltexlib.c, lua/ltokenlib.c, lua/luainit.c,
	lua/luanode.c, lua/luastuff.c, lua/luatex.c, lua/luatoken.c,
	luatex.ch, tex/filename.c, tex/linebreak.c, tex/math.c,
	tex/mlist.c, tex/primitive.c, tex/texdeffont.c, tex/texnodes.c,
	tex/textoken.c, utils/utils.c: Declare various function params
	and args, local and global vars, and struct members as const.

	* font/luafont.c, font/texfont.c, font/tfmofm.c, font/vfovf.c,
	font/writeenc.c, font/writefont.c, font/writet1.c,
	font/vfpacket.c, font/writettf.c, font/writetype2.c,
	image/writeimg.c, lang/hyphen.c, lang/texlang.c, lua/limglib.c,
	lua/llualib.c, lua/lnodelib.c, lua/loslibext.c, lua/lpdflib.c,
	lua/lstatslib.c, lua/ltexlib.c, lua/luainit.c, lua/luanode.c,
	lua/luastuff.c, mathcodes.c, tex/linebreak.c, tex/math.c,
	tex/mlist.c, tex/primitive.c, tex/texdeffont.c, tex/texnodes.c,
	tex/textoken.c, utils/synctex.c, utils/utils.c:
	Declare functions and global vars as static.

	* font/texfont.c: #include "luatexfont.h" and remove externs.
	* image/writejpg.c: #include "writejpg.h".
	* image/writepng.c: #include "writepng.h".
	* lang/hnjalloc.c: #include "hnjalloc.h".
	* lua/texluac.c: #include "luatex-api.h".
	* utils/synctex.c: #include "synctex.h".
	* utils/utils.c: #include "utils.h".

	* lua/lcallbacklib.c: Remove prototype for lua_traceback().
	* ptexlib.h: Add prototype for get_command_id() ...
	* lua/ltokenlib.c: ... removed from here.
	* nodes.h: Add prototype for list_node_mem_usage() ...
	* lua/lnodelib.c: ... removed from here.
	* managed-sa.h: Add prototype for rawset_sa_item() ...
	* mathcodes.c, tex/math.c: ... removed from here.

	* inc-epdf.h: New file with prototypes for epdf_mark_glyphs(),
	epdf_create_fontdescriptor(), and epdf_write_enc() ...
	* image/epdf.h: ... removed from here.
	* image/epdf.h, font/writeenc.c: #include inc-epdf.h.
	* inc-vfovf.h: New file with prototype for make_vf_table() ...
	* lua/lfontlib.c: ... removed from here.
	* font/vfovf.c, lua/lfontlib.c: #include inc-vfovf.h.
	* inc-extra.h: New file with prototypes for check_isnode()
	and lua_nodelib_push_fast() ...
	* lua/limglib.c, lua/llanglib.c, lua/lstatslib.c, lua/ltexlib.c:
	... removed from here.
	* lua/limglib.c, lua/llanglib.c, lua/lnodelib.c,
	lua/lstatslib.c, lua/ltexlib.c: #include "inc-extra.h".
	* am/libluatex.am (libluatex_a_SOURCES): Add the new files.

	* font/texfont.c (lua_char_exists_callback),
	font/vfovf.c (is_letterspaced_font),
	font/vfpacket.c (packet_command_names),
	font/writet1.c (free_glyph_names),
	image/writeimg.c (image_group_ref),
	lua/ltexlib.c (get_something_internal),
	tex/texnodes.c (print_free_chain),
	textcodes.c (clearcatcodestack):
	Skip unused static funcs and vars (via #if 0 ... #endif).

	* lua/luainit.c (lua_initialize): Replace string constant
	arguments of putenv() by non-const static string variables.

	* utils/avl.c (avl_delete): Don't reuse const input param for
	non-const return value.

	* utils/synctex.c: Rename synctexchar => synctex_char and
	synctexnode => synctex_node as declared in utils/synctex.h.

2010-01-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatangle.ch: Declare web_name, chg_name, pascal_name, and
	pool_name as const_c_string.

	* lua/lkpselib.c (readable_file, lua_kpathsea_readable_file):
	Drop non-const cast of {kpse,kpathsea}_readable_file() result.

2010-01-03  Karl Berry  <karl@tug.org>

	* luatex.ch: propagate "executed safely" wording change.

2009-12-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/luatex.am: Replace the obsolete $(mkdir_p) by $(MKDIR_P).

2009-12-07  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/loslibext.c (do_mkdtemp): Declare as static and skip
	compilation when not used.

2009-12-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdf/pagetree.c, utils/utils.c: Drop #ifdef HAVE_ASPRINTF and
	#include <stdio.h>.

2009-12-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* utils/synctex.c: Remove (already commented) extern declaration
	of gettexstring().

2009-10-24  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatex.web: Use kpse_{in,out}_name_ok(), now in Kpathsea,
	instead of open{in,out}nameok().
	* luatex.defines: Replace open_{in,out}_name_ok by
	kpse_{in,out}_name_ok.

2009-10-07  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* image/pdftoepdf.cc: Adapt to poppler-0.12.

	* FIXME: image/epdf.h, utils/utils.h: Multiple prototypes for
	pdftex_fail, pdftex_warn, and probably others.

2009-09-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/luatex.am: Adapt to new makecpool with one argument.

2009-09-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/luainit.c (dump_name, c_job_name, last_source_name,
	last_lineno): Drop extern declarations (now in texmfmp.h).
	(user_progname): Constify string.
	(lua_initialize): Avoid modifying the const_string 'dump_name'.

2009-09-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* utils/synctex.c (synctex_suffix*): Constify strings.

2009-09-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatangle.ch: Eliminate the unused |end_of_TANGLE| label.

2009-09-02  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/libzzip.am: Enable compiler warnings.
	* am/liblua51.am, am/libluatex.am, am/luafontforge.am,
	am/luamisc.am, am/luasocket.am, am/luatex.am: Prepare compiler
	warnings.

2009-08-20  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/lstatslib.c, lua/luainit.c: Drop extern decl of ptexbanner.
	* utils/utils.c: #include <kpathsea/version.h> and drop extern
	decls.

2009-08-17  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/liolib.c (io_popen): Changed Arg1 of shell_cmd_is_allowed().
	* lua/loslibext.c (os_exec, os_spawn, os_execute): Same.

2009-08-16  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/luatangle.am: Adapt to web2c-sh.
	* am/luatex.am (luatex_tangle): Use tangle-sh.
	Adapt to tangle-sh and web2c-sh.

2009-06-26  Taco Hoekwater <taco@luatex.org>

	* lua51/lcoco.c, lua51/lcoco.h: disable the coco patch on
	linux+ppc because it crashes the executable.

2009-06-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* font/writet1.c, image/epdf.[ch], utils/avlstuff.c:
	remove #include <kpathsea/c-proto.h>.
 	
2009-06-25  Taco Hoekwater <taco@luatex.org>
 	
	* luatexdir: import of luatex release 0.40.6.

2009-06-23  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* lua/luatex.c: drop P?C, P?H, use ANSI C function declarations.

2009-06-23  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* font/writet1.c, image/epdf.c, utils/avlstuff.c:
	#include <stdarg.h>, not <kpathsea/c-vararg.h>.

2009-06-09  Taco Hoekwater <taco@luatex.org>
 	
	* luatexdir: import of luatex release 0.40.4.

2009-06-08  Taco Hoekwater <taco@luatex.org>
 	
	* luatexdir: import of luatex release 0.40.3.
	This affects many files in subdirectories.

2009-06-04  Taco Hoekwater <taco@luatex.org>
	
	* luatexdir: "avoid variable declaration after statement" patch
	from Vladimir Volovich

2009-06-03  Taco Hoekwater <taco@luatex.org>
 	
	* luatexdir/luafontloader/fontforge/fontforge/namelist.c (psaltnames): add
	a dimension specifier, for AIX portability.

2009-06-03  Taco Hoekwater <taco@luatex.org>
 	
	* luatexdir: import of luatex release 0.40.2.
	This affects many files in subdirectories.

2009-05-30  Peter Breitenlohner <peb@mppmu.mpg.de>

	* am/luatex.am (install-exec-hook, uninstall-hook):
	avoid dangling symlinks.

2009-05-25  Peter Breitenlohner <peb@mppmu.mpg.de>

	* am/luatex.am (uninstall-hook): new target to uninstall texlua[c]
	symlinks.

2009-05-25  Karl Berry  <karl@tug.org>

	* am/luatex.am (install-exec-hook): new target to install texlua[c]
	symlinks.

2009-05-08  Taco Hoekwater <taco@luatex.org>
 	
	* luatexdir: import of the current state of luatex, 0.40.1.
	This affects many files in subdirectories.

2009-05-05  Peter Breitenlohner <peb@mppmu.mpg.de>

	* image/pdftoepdf.cc, utils/utils.c: adapt for poppler.

	patches from Norbert Preinig <preining@logic.at>

2009-04-27  Taco Hoekwater <taco@luatex.org>

	* pdf/pdfpage.c: rename exp10 to exp10_arr to solve a 
	conflict with cygwin's <math.h>.
	* font/texfont.h: add #undef quad before definition to suppress a
	compiler warning under cygwin. 

2009-04-22  Taco Hoekwater <taco@luatex.org>

	* luatexdir: import of the current state of luatex, 0.40.0. 
	This affects many files in subdirectories.

2009-04-16  Taco Hoekwater <taco@luatex.org>

	* image/image.h: remove the trick that forced a local png.h

2009-04-16  Taco Hoekwater <taco@luatex.org>

	* luatexdir: import of the current state of luatex, 0.39.0. 
	This affects many files in subdirectories.

2009-03-27  Peter Breitenlohner <peb@mppmu.mpg.de>

	* am/luatex.am (luatex_c_h): avoid to split the C code
	(from Taco).

2009-03-27  Taco Hoekwater <taco@luatex.org>

	* luatexdir: import of the current state of luatex, 0.37.0. 
	This affects many files in subdirectories.

2009-03-05  Peter Breitenlohner <peb@mppmu.mpg.de>

	* image/pdftoepdf.cc: Uninclude <config.h>, included later
	by "epdf.h".

2009-03-03  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* luatangle.ch: use kpse_open_file to locate input files,
	in order to respect WEBINPUTS (ported from tangle.ch).
